﻿Public Class frmHello

    Dim buttonSystemColor As Object

    Dim xPos As Integer

    Dim intervValue As Integer
    Dim intervUnit As String
    Dim intervStartVisible As Integer

    Dim Store_intervStartVisible As Integer
    Dim Store_picLogikDiagramScrollBar As Integer
    Dim store_DataColCountVisible As Integer

    Dim yPos1_0 As Integer = 28
    Dim yPos1_100 As Integer = 42

    Dim yPos2_0 As Integer = 55
    Dim yPos2_100 As Integer = 69

    Dim yPos3_0 As Integer = 80
    Dim yPos3_100 As Integer = 94

    Dim yPos4_0 As Integer = 106
    Dim yPos4_100 As Integer = 120

    Dim yPos5_0 As Integer = 131
    Dim yPos5_100 As Integer = 145

    Dim yPos6_0 As Integer = 157
    Dim yPos6_100 As Integer = 171

    Dim yPos7_0 As Integer = 183
    Dim yPos7_100 As Integer = 197

    Dim yPos8_0 As Integer = 209
    Dim yPos8_100 As Integer = 223

    Dim xStep As Integer = 25


    Private Sub frmHello_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        '**********************************************************************************************
        '*** operation once, when programm ends finally
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger


        '*** do closing operation package

        'clear message text on RoboTXController
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetRoboTxMessage(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, "")

        'do all waiting jobs before closing
        System.Windows.Forms.Application.DoEvents()
        System.Threading.Thread.Sleep(500)

        'closing operation
        errCode1 = classFtMscLib.FtLibDeclarations.ftxStopTransferArea(glFtHdl)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxCloseDevice(glFtHdl)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxCloseLib()

    End Sub

    Private Sub frmHello_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '**********************************************************************************************
        '*** operation once, when programm starts the first time
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim n As Integer


        '*** do form loading operation package

        'prepare main operation button
        buttonSystemColor = Me.btnMainOperation.BackColor
        Me.btnMainOperation.BackColor = Color.Red

        'feed com channel combo box
        ListComChannels()
        n = 0
feedLoop:
        If glComChannels(n) <> "EOF" Then
            Me.cboComConnections.Items.Add(glComChannels(n))
            n = n + 1
            GoTo feedLoop
        End If

        'set applcation window title
        Me.Text = Application.ProductName & "   version " & Application.ProductVersion & "   for fischertechnik Robo TX Controller   " & Application.CompanyName

        'set variables
        glDataColMax = 0
        xPos = 0
        glDataCol(0, 1) = 0
        glDataCol(0, 2) = 0
        glDataCol(0, 3) = 0
        glDataCol(0, 4) = 0
        glDataCol(0, 5) = 0
        glDataCol(0, 6) = 0
        glDataCol(0, 7) = 0
        glDataCol(0, 8) = 0

        intervStartVisible = 0
        intervValue = 1
        intervUnit = "s"

        'set status
        Me.picLogikDiagramScrollBar.Enabled = False

    End Sub

    Private Sub btnMainOperation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMainOperation.Click

        '**********************************************************************************************
        '*** main operation of serial function chains, on or off
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger


        '*** check selected mode

        If Me.btnMainOperation.Text = "process stopped" Then
            '*** serial function chains active
            'change button appearance
            Me.btnMainOperation.Text = "process running"
            Me.btnMainOperation.BackColor = Color.Green
            Me.tmrFlash.Enabled = True
            'inactivate button for com channel disconnect
            Me.btnComConnect.Enabled = False
            'write message to operation log
            OperationLogAddItem("")
            OperationLogAddItem("*** manual operation mode changed to 'process running'")
            'define working cycle interval
            Me.tmrWorkingCycle001.Interval = 1000 'do it every ...ms
            Me.tmrWorkingCycle002.Interval = 1000 'do it every ...ms
            Me.tmrWorkingCycle003.Interval = 1000 'do it every ...ms
            System.Windows.Forms.Application.DoEvents()
            'define a new working cycle session
            glWC001FirstLoop = True
            glWC002FirstLoop = True
            glWC003FirstLoop = True
            'activate working cycle process
            Me.tmrWorkingCycle001.Enabled = False   'WorkingCycle 1 will be activated with buttons
            Me.tmrWorkingCycle002.Enabled = False   'WorkingCycle 2 is not used
            Me.tmrWorkingCycle003.Enabled = False   'WorkingCycle 3 is not used
            System.Windows.Forms.Application.DoEvents()
            Me.cmdClear.Enabled = True
            Me.cmdStart.Enabled = True
            Me.cmdStop.Enabled = False
            Me.picLogikDiagramScrollBar.Enabled = True
        Else
            '*** serial function chains stopped
            'deactivate working cycle process
            Me.tmrWorkingCycle001.Enabled = False   'stop WorkingCycle 1
            Me.tmrWorkingCycle002.Enabled = False   'stop WorkingCycle 2
            Me.tmrWorkingCycle003.Enabled = False   'stop WorkingCycle 3
            System.Windows.Forms.Application.DoEvents()
            'change button appearance
            Me.btnMainOperation.Text = "process stopped"
            Me.btnMainOperation.BackColor = Color.Red
            Me.tmrFlash.Enabled = False
            'inactivate button for com channel disconnect
            Me.btnComConnect.Enabled = True
            'write message to operation log
            OperationLogAddItem("")
            OperationLogAddItem("*** manual operation mode changed to 'process stopped'")
            Me.cmdClear.Enabled = False
            Me.cmdStart.Enabled = False
            Me.cmdStop.Enabled = False
            Me.picLogikDiagramScrollBar.Enabled = False
        End If

    End Sub

    Public Sub OperationLogAddItem(ByVal NewItem)

        '**********************************************************************************************
        '*** add one item to operation log list box
        '**********************************************************************************************

        'On Error Resume Next

        '*** variable declaration

        Dim linesCount As Integer


        'adds a new item to operation log control
        Me.lstbOperationLog.Items.Add(NewItem)

        'scroll to show always the last item
        linesCount = Me.lstbOperationLog.Items.Count - 1
        Me.lstbOperationLog.SetSelected(linesCount, True)
        Me.lstbOperationLog.SetSelected(linesCount, False)

    End Sub

    Private Sub chkShowOperationLog_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkShowOperationLog.CheckedChanged

        '**********************************************************************************************
        '*** show or hide operation log window
        '**********************************************************************************************

        On Error Resume Next

        If Me.chkShowOperationLog.Checked = True Then
            Me.Height = 693
            Me.Controls.Item("lstbOperationLog").Top = 470
            Me.lstbOperationLog.Visible = True
        Else
            Me.lstbOperationLog.Visible = False
            Me.Controls.Item("lstbOperationLog").Top = 52
            Me.Height = 493
        End If

    End Sub

    Private Sub tmrWorkingCycle001_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrWorkingCycle001.Tick

        '**********************************************************************************************
        '*** serial function chain operation of separate parallel working cycle 1
        '**********************************************************************************************

        On Error Resume Next

        WorkingCycle001()

    End Sub

    Private Sub tmrWorkingCycle002_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrWorkingCycle002.Tick

        '**********************************************************************************************
        '*** serial function chain operation of separate parallel working cycle 2
        '**********************************************************************************************

        On Error Resume Next

        WorkingCycle002()


    End Sub

    Private Sub tmrWorkingCycle003_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrWorkingCycle003.Tick

        '**********************************************************************************************
        '*** serial function chain operation of separate parallel working cycle 3
        '**********************************************************************************************

        On Error Resume Next

        WorkingCycle003()

    End Sub

    Private Sub tmrFlash_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrFlash.Tick

        '**********************************************************************************************
        '*** flash effect to indicate serial function chains are running
        '**********************************************************************************************

        On Error Resume Next

        If Me.btnMainOperation.BackColor = Color.Green Then
            Me.btnMainOperation.BackColor = buttonSystemColor
        Else
            Me.btnMainOperation.BackColor = Color.Green
        End If

    End Sub

    Private Sub btnComConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnComConnect.Click

        '**********************************************************************************************
        '*** connect via a chosen com port to a RoboTXController
        '**********************************************************************************************

        On Error Resume Next

        If Me.btnComConnect.Text = "connect" Then
            glThreadComConOK = False
            DoComConnection(Me.cboComConnections.SelectedItem)
            If glThreadComConOK = True Then
                Me.btnComConnect.Text = "disconnect"
                RoboTXControllerInfo()
                Me.cboComConnections.Enabled = False
                Me.btnMainOperation.Enabled = True
            Else
                MsgBox("Connection to " & glComSelectionMod & " failed. " & ControlChars.Cr & ControlChars.Cr & "Check your hardware setup or select an other com channel.", MsgBoxStyle.Critical, Application.ProductName & " - connection error")
            End If
        Else
            Me.btnComConnect.Text = "connect"
            DoComDisonnection()
            Me.cboComConnections.Enabled = True
            Me.btnMainOperation.Enabled = False
        End If

    End Sub

    Private Sub cboComConnections_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboComConnections.SelectedIndexChanged

        '**********************************************************************************************
        '*** a com channel selection was made
        '**********************************************************************************************

        On Error Resume Next

        Dim comItem As String

        comItem = Me.cboComConnections.SelectedItem

        If String.IsNullOrEmpty(comItem) = True Then
            Me.btnComConnect.Enabled = False
        Else
            If Strings.UCase(Strings.Left(comItem, 3)) = "COM" And Char.IsNumber(comItem, 3) = True Then
                Me.btnComConnect.Enabled = True
            Else
                Me.btnComConnect.Enabled = False
            End If
        End If

    End Sub

    Private Sub cboComConnections_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboComConnections.TextChanged

        '**********************************************************************************************
        '*** a com channel text change was made, this is not allowed
        '**********************************************************************************************

        On Error Resume Next

        Me.btnComConnect.Enabled = False

    End Sub


    Private Sub btnInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInfo.Click

        '**********************************************************************************************
        '*** program info box
        '**********************************************************************************************

        '*** variable declaration
        Dim txtMsg As Object

        txtMsg = Application.ProductName & ", vers. " & Application.ProductVersion
        txtMsg = txtMsg & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & Application.CompanyName & ", 2015" & ControlChars.Cr
        txtMsg = txtMsg & "for fischertechnik Robo TX Controller" & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "Program demonstrates how to use VisualBasic 2010 to control Fischertechnik" & ControlChars.Cr
        txtMsg = txtMsg & "models as an altertative to other developement invironments." & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "You can feel free to copy or distribute the project, but you must pay attention " & ControlChars.Cr
        txtMsg = txtMsg & "to the rights of microsoft, fischertechnik and others." & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "No guarantee, all on your own risk." & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "To publish your results would be appreciated by the community, e.g. under www.ftcommunity.de" & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "Special thanks to Carel van Leeuwen for basic information and support. Watch his pages:" & ControlChars.Cr
        txtMsg = txtMsg & "http://nl.linkedin.com/pub/carel-van-leeuwen/11/ba0/504" & ControlChars.Cr
        txtMsg = txtMsg & "http://web.inter.nl.net/users/Ussel-IntDev/"

        MsgBox(txtMsg, MsgBoxStyle.Information, Application.ProductName & " - version info")

    End Sub

    Public Sub WritePicFrame()

        Dim PicFrame As System.Drawing.Graphics

        xPos = xPos + xStep

        PicFrame = Me.picLogikDiagram.CreateGraphics

        'channel 1
        If glDataCol(glDataColMax, 1) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Red, 2), xPos - xStep, yPos1_0, xPos, yPos1_0)
        End If
        If glDataCol(glDataColMax, 1) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Red, 2), xPos - xStep, yPos1_100, xPos, yPos1_100)
        End If
        If glDataCol(glDataColMax, 1) <> glDataCol(glDataColMax - 1, 1) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Red, 2), xPos - xStep, yPos1_100, xPos - xStep, yPos1_0)
        End If

        'channel 2
        If glDataCol(glDataColMax, 2) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Blue, 2), xPos - xStep, yPos2_0, xPos, yPos2_0)
        End If
        If glDataCol(glDataColMax, 2) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Blue, 2), xPos - xStep, yPos2_100, xPos, yPos2_100)
        End If
        If glDataCol(glDataColMax, 2) <> glDataCol(glDataColMax - 1, 2) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Blue, 2), xPos - xStep, yPos2_100, xPos - xStep, yPos2_0)
        End If

        'channel 3
        If glDataCol(glDataColMax, 3) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Green, 2), xPos - xStep, yPos3_0, xPos, yPos3_0)
        End If
        If glDataCol(glDataColMax, 3) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Green, 2), xPos - xStep, yPos3_100, xPos, yPos3_100)
        End If
        If glDataCol(glDataColMax, 3) <> glDataCol(glDataColMax - 1, 3) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Green, 2), xPos - xStep, yPos3_100, xPos - xStep, yPos3_0)
        End If

        'channel 4
        If glDataCol(glDataColMax, 4) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Orange, 2), xPos - xStep, yPos4_0, xPos, yPos4_0)
        End If
        If glDataCol(glDataColMax, 4) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Orange, 2), xPos - xStep, yPos4_100, xPos, yPos4_100)
        End If
        If glDataCol(glDataColMax, 4) <> glDataCol(glDataColMax - 1, 4) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Orange, 2), xPos - xStep, yPos4_100, xPos - xStep, yPos4_0)
        End If

        'channel 5
        If glDataCol(glDataColMax, 5) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Magenta, 2), xPos - xStep, yPos5_0, xPos, yPos5_0)
        End If
        If glDataCol(glDataColMax, 5) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Magenta, 2), xPos - xStep, yPos5_100, xPos, yPos5_100)
        End If
        If glDataCol(glDataColMax, 5) <> glDataCol(glDataColMax - 1, 5) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Magenta, 2), xPos - xStep, yPos5_100, xPos - xStep, yPos5_0)
        End If

        'channel 6
        If glDataCol(glDataColMax, 6) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.DarkCyan, 2), xPos - xStep, yPos6_0, xPos, yPos6_0)
        End If
        If glDataCol(glDataColMax, 6) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.DarkCyan, 2), xPos - xStep, yPos6_100, xPos, yPos6_100)
        End If
        If glDataCol(glDataColMax, 6) <> glDataCol(glDataColMax - 1, 6) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.DarkCyan, 2), xPos - xStep, yPos6_100, xPos - xStep, yPos6_0)
        End If

        'channel 7
        If glDataCol(glDataColMax, 7) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Brown, 2), xPos - xStep, yPos7_0, xPos, yPos7_0)
        End If
        If glDataCol(glDataColMax, 7) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Brown, 2), xPos - xStep, yPos7_100, xPos, yPos7_100)
        End If
        If glDataCol(glDataColMax, 7) <> glDataCol(glDataColMax - 1, 7) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.Brown, 2), xPos - xStep, yPos7_100, xPos - xStep, yPos7_0)
        End If

        'channel 8
        If glDataCol(glDataColMax, 8) = 0 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.BlueViolet, 2), xPos - xStep, yPos8_0, xPos, yPos8_0)
        End If
        If glDataCol(glDataColMax, 8) = 100 Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.BlueViolet, 2), xPos - xStep, yPos8_100, xPos, yPos8_100)
        End If
        If glDataCol(glDataColMax, 8) <> glDataCol(glDataColMax - 1, 8) Then
            PicFrame.DrawLine(New Pen(System.Drawing.Color.BlueViolet, 2), xPos - xStep, yPos8_100, xPos - xStep, yPos8_0)
        End If

        'Debug.Print("glDataColMax=" & glDataColMax)

        'check end of windwow frame
        If glDataColMax / 20 = Int(glDataColMax / 20) And glDataColMax > 30 Then
            'reload blank graphic background
            Me.picLogikDiagram.Refresh()
            'continue in the middle of window frame
            xPos = xPos - 20 * xStep
            'write labels
            intervStartVisible = intervStartVisible + 20 * intervValue
            WriteLabels()
            'rewrite a part of history
            ReWritePicFrame(glDataColMax - 20, 20)
            'update scroll bat
        End If

    End Sub

    Private Sub ReWritePicFrame(ByVal DataStart As Integer, ByVal DataCounter As Integer)

        Dim NxPos As Integer
        Dim PicFrame As System.Drawing.Graphics
        PicFrame = Me.picLogikDiagram.CreateGraphics

        NxPos = 0

        For n = DataStart To DataStart + DataCounter

            'channel 1
            If glDataCol(n, 1) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Red, 2), NxPos - xStep, yPos1_0, NxPos, yPos1_0)
            End If
            If glDataCol(n, 1) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Red, 2), NxPos - xStep, yPos1_100, NxPos, yPos1_100)
            End If
            If n > 0 Then
                If glDataCol(n, 1) <> glDataCol(n - 1, 1) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.Red, 2), NxPos - xStep, yPos1_100, NxPos - xStep, yPos1_0)
                End If
            End If

            'channel 2
            If glDataCol(n, 2) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Blue, 2), NxPos - xStep, yPos2_0, NxPos, yPos2_0)
            End If
            If glDataCol(n, 2) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Blue, 2), NxPos - xStep, yPos2_100, NxPos, yPos2_100)
            End If
            If n > 0 Then
                If glDataCol(n, 2) <> glDataCol(n - 1, 2) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.Blue, 2), NxPos - xStep, yPos2_100, NxPos - xStep, yPos2_0)
                End If
            End If

            'channel 3
            If glDataCol(n, 3) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Green, 2), NxPos - xStep, yPos3_0, NxPos, yPos3_0)
            End If
            If glDataCol(n, 3) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Green, 2), NxPos - xStep, yPos3_100, NxPos, yPos3_100)
            End If
            If n > 0 Then
                If glDataCol(n, 3) <> glDataCol(n - 1, 3) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.Green, 2), NxPos - xStep, yPos3_100, NxPos - xStep, yPos3_0)
                End If
            End If

            'channel 4
            If glDataCol(n, 4) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Orange, 2), NxPos - xStep, yPos4_0, NxPos, yPos4_0)
            End If
            If glDataCol(n, 4) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Orange, 2), NxPos - xStep, yPos4_100, NxPos, yPos4_100)
            End If
            If n > 0 Then
                If glDataCol(n, 4) <> glDataCol(n - 1, 4) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.Orange, 2), NxPos - xStep, yPos4_100, NxPos - xStep, yPos4_0)
                End If
            End If

            'channel 5
            If glDataCol(n, 5) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Magenta, 2), NxPos - xStep, yPos5_0, NxPos, yPos5_0)
            End If
            If glDataCol(n, 5) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Magenta, 2), NxPos - xStep, yPos5_100, NxPos, yPos5_100)
            End If
            If n > 0 Then
                If glDataCol(n, 5) <> glDataCol(n - 1, 5) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.Magenta, 2), NxPos - xStep, yPos5_100, NxPos - xStep, yPos5_0)
                End If
            End If

            'channel 6
            If glDataCol(n, 6) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.DarkCyan, 2), NxPos - xStep, yPos6_0, NxPos, yPos6_0)
            End If
            If glDataCol(n, 6) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.DarkCyan, 2), NxPos - xStep, yPos6_100, NxPos, yPos6_100)
            End If
            If n > 0 Then
                If glDataCol(n, 6) <> glDataCol(n - 1, 6) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.DarkCyan, 2), NxPos - xStep, yPos6_100, NxPos - xStep, yPos6_0)
                End If
            End If

            'channel 7
            If glDataCol(n, 7) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Brown, 2), NxPos - xStep, yPos7_0, NxPos, yPos7_0)
            End If
            If glDataCol(n, 7) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.Brown, 2), NxPos - xStep, yPos7_100, NxPos, yPos7_100)
            End If
            If n > 0 Then
                If glDataCol(n, 7) <> glDataCol(n - 1, 7) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.Brown, 2), NxPos - xStep, yPos7_100, NxPos - xStep, yPos7_0)
                End If
            End If

            'channel 8
            If glDataCol(n, 8) = 0 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.BlueViolet, 2), NxPos - xStep, yPos8_0, NxPos, yPos8_0)
            End If
            If glDataCol(n, 8) = 100 Then
                PicFrame.DrawLine(New Pen(System.Drawing.Color.BlueViolet, 2), NxPos - xStep, yPos8_100, NxPos, yPos8_100)
            End If
            If n > 0 Then
                If glDataCol(n, 8) <> glDataCol(n - 1, 8) Then
                    PicFrame.DrawLine(New Pen(System.Drawing.Color.BlueViolet, 2), NxPos - xStep, yPos8_100, NxPos - xStep, yPos8_0)
                End If
            End If

            NxPos = NxPos + xStep

        Next

    End Sub

    Private Sub cboDrawRate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboDrawRate.SelectedIndexChanged

        'Debug.Print(cboDrawRate.Text)

        tmrWorkingCycle001.Enabled = False

        Me.cmdStart.Text = "start"

        tmrWorkingCycle001.Interval = 1000

        If cboDrawRate.Text = "1s" Then
            Me.tmrWorkingCycle001.Interval = 1000
            intervValue = 1
            intervUnit = "s"
        End If

        If cboDrawRate.Text = "2s" Then
            Me.tmrWorkingCycle001.Interval = 2000
            intervValue = 2
            intervUnit = "s"
        End If

        If cboDrawRate.Text = "5s" Then
            Me.tmrWorkingCycle001.Interval = 5000
            intervValue = 5
            intervUnit = "s"
        End If

        If cboDrawRate.Text = "10s" Then
            Me.tmrWorkingCycle001.Interval = 10000
            intervValue = 10
            intervUnit = "s"
        End If

        If cboDrawRate.Text = "25ms" Then
            Me.tmrWorkingCycle001.Interval = 25
            intervValue = 25
            intervUnit = "ms"
        End If

        If cboDrawRate.Text = "50ms" Then
            Me.tmrWorkingCycle001.Interval = 50
            intervValue = 50
            intervUnit = "ms"
        End If

        If cboDrawRate.Text = "100ms" Then
            Me.tmrWorkingCycle001.Interval = 100
            intervValue = 100
            intervUnit = "ms"
        End If

        If cboDrawRate.Text = "250ms" Then
            Me.tmrWorkingCycle001.Interval = 250
            intervValue = 250
            intervUnit = "ms"
        End If

        If cboDrawRate.Text = "500ms" Then
            Me.tmrWorkingCycle001.Interval = 500
            intervValue = 500
            intervUnit = "ms"
        End If

        Me.cmdStop.PerformClick()
        Me.cmdClear.PerformClick()

        WriteLabels()

    End Sub

    Private Sub cmdStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStart.Click

        If glDataColMax > 0 Then
            'reload blank graphic background
            Me.picLogikDiagram.Refresh()
            Me.picLogikDiagramScrollBar.Value = Store_picLogikDiagramScrollBar
            intervStartVisible = Store_intervStartVisible
            ReWritePicFrame(glDataColMax - store_DataColCountVisible, store_DataColCountVisible)
            Me.picLogikDiagramScrollBar.Select()
        End If

        Me.tmrWorkingCycle001.Enabled = True
        Me.cmdStop.Enabled = True
        Me.cmdStart.Enabled = False
        Me.cmdSave.Enabled = False
        Me.picLogikDiagramScrollBar.Enabled = False
        WriteLabels()
    End Sub

    Private Sub cmdStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStop.Click

        On Error Resume Next

        Dim ProgressCalc As Integer

        Me.tmrWorkingCycle001.Enabled = False
        Me.cmdStop.Enabled = False
        Me.cmdStart.Enabled = True
        Me.cmdStart.Text = "continue"
        Me.cmdSave.Enabled = True

        If glDataColMax > 0 Then ProgressCalc = Int((intervStartVisible / intervValue) / glDataColMax * 100)
        If ProgressCalc = 0 Then ProgressCalc = 1
        Me.picLogikDiagramScrollBar.Value = ProgressCalc

        Me.picLogikDiagramScrollBar.Enabled = True

        Store_picLogikDiagramScrollBar = ProgressCalc
        Store_intervStartVisible = intervStartVisible
        store_DataColCountVisible = Int(xPos / xStep)

        'Debug.Print("intervStartVisible=" & intervStartVisible & " intervValue=" & intervValue & " glDataColMax=" & glDataColMax & " ProgressCalc=" & ProgressCalc)

    End Sub

    Private Sub cmdClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear.Click

        'reset variables
        glDataColMax = 0
        intervStartVisible = 0
        xPos = 0
        WriteLabels()

        'reload blank graphic background
        Me.picLogikDiagram.Refresh()

        'reset scroll bar
        Me.picLogikDiagramScrollBar.Value = 1

        Me.cmdSave.Enabled = False

        Me.cmdStart.Text = "start"

    End Sub

    Private Sub WriteLabels()

        Me.txtLD_info1.Text = intervStartVisible & intervUnit
        Me.txtLD_info2.Text = intervStartVisible + 10 * intervValue & intervUnit
        Me.txtLD_info3.Text = intervStartVisible + 20 * intervValue & intervUnit
        Me.txtLD_info4.Text = intervStartVisible + 30 * intervValue & intervUnit
        Me.txtLD_info5.Text = intervStartVisible + 40 * intervValue & intervUnit

    End Sub

    Private Sub picLogikDiagramScrollBar_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles picLogikDiagramScrollBar.Scroll

        Dim SliderValue As Integer
        Dim ScreensCount As Integer
        Dim ScreensSelection As Integer
        Dim RestDataPoints As Integer

        'reload blank graphic background
        Me.picLogikDiagram.Refresh()

        SliderValue = Me.picLogikDiagramScrollBar.Value
        ScreensCount = Int(glDataColMax / 10) + 1
        ScreensSelection = Int(ScreensCount * (SliderValue / 100))
        If ScreensSelection = ScreensCount Then ScreensSelection = ScreensCount - 1

        'write labels
        intervStartVisible = ScreensSelection * 10 * intervValue
        WriteLabels()

        'rewrite data lines
        RestDataPoints = glDataColMax - (ScreensSelection * 10)

        If RestDataPoints > 40 Then RestDataPoints = 40
        ReWritePicFrame(ScreensSelection * 10, RestDataPoints)

        'Debug.Print(SliderValue & "; " & glDataColMax & "; " & ScreensConut & "; " & ScreensSelection & "; " & RestDataPoints)

    End Sub

    Private Sub cmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSave.Click

        Dim OutputFileName As String
        Dim OutputWriter As System.IO.StreamWriter

        Me.SaveFileDialog1.Filter = "table (*.csv)|*.csv"
        If Me.SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            OutputFileName = SaveFileDialog1.FileName
            'Debug.Print(OutputFileName)
            OutputWriter = System.IO.File.CreateText(OutputFileName)
            OutputWriter.WriteLine("No;time in " & intervUnit & ";line 1;line 2;line 3;line 4;line 5;line 6;line 7;line 8")
            For n = 1 To glDataColMax
                OutputWriter.WriteLine(n & ";" & (n - 1) * intervValue & ";" & glDataCol(n, 1) & ";" & glDataCol(n, 2) & ";" & glDataCol(n, 3) & ";" & glDataCol(n, 4) & ";" & glDataCol(n, 5) & ";" & glDataCol(n, 6) & ";" & glDataCol(n, 7) & ";" & glDataCol(n, 8))
            Next
            OutputWriter.Close()
        End If

    End Sub

End Class
